Bug 1259460 - Review Request: libu2f-server - Yubico Universal 2nd Factor (U2F) Server C Library
Summary: Review Request: libu2f-server - Yubico Universal 2nd Factor (U2F) Server C Li...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Andy Lutomirski
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-09-02 16:15 UTC by Seth Jennings
Modified: 2015-11-13 01:52 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-11-12 23:29:25 UTC
Type: ---
luto: fedora-review+


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 1155826 medium CLOSED Review Request: libu2f-host - Yubico Universal 2nd Factor (U2F) Host C Library 2021-01-20 06:05:38 UTC

Internal Links: 1155826

Description Seth Jennings 2015-09-02 16:15:23 UTC
Spec URL: https://www.variantweb.net/pub/review/libu2f-server.spec
SRPM URL: https://www.variantweb.net/pub/review/libu2f-server-1.0.1-1.fc22.src.rpm
Koji Build: http://koji.fedoraproject.org/koji/taskinfo?taskID=10929687

Description:
This is a C library that implements the server-side of the U2F protocol. More
precisely, it provides an API for generating the JSON blobs required by U2F
devices to perform the U2F Registration and U2F Authentication operations, and
functionality for verifying the cryptographic operations.

Fedora Account System Username: spartacus06

Comment 1 Seth Jennings 2015-09-02 16:20:41 UTC
See also for related package review:
https://bugzilla.redhat.com/show_bug.cgi?id=1155826

Spec files are very similar.  Reviewing one pretty much reviews the other.

Comment 2 Andy Lutomirski 2015-10-27 00:16:37 UTC
Let's get the show on the road.  I got this.

Comment 3 Andy Lutomirski 2015-10-27 01:38:19 UTC
Minor nit: I don't think that %license COPYING is needed in u2f-server, because u2f-server requires the main package.

Also, please enable _hardened_build.  See below, too -- you have an unnecessary %license, and I think that should be fixed prior to release.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT/X11 (BSD like)", "BSD (2 clause)", "GPL (v2 or later)",
     "Unknown or generated". 63 files have unknown license. Detailed output
     of licensecheck in /home/luto/devel/fedora/libu2f-server/libu2f-
     server/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.

^^^ yes, but overkill in this case

[x]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/share/gtk-doc(gnome-
     desktop3-devel, libcanberra-devel, libgnome-keyring-devel,
     webkitgtk3-doc, gtk3-devel-docs, gcr-devel, polkit-docs, libgweather-
     devel, harfbuzz-devel, libsecret-devel, json-glib-devel, libgdata-
     devel, p11-kit-devel, gtk-doc), /usr/share/gtk-doc/html(gnome-
     desktop3-devel, libcanberra-devel, libgnome-keyring-devel,
     webkitgtk3-doc, gtk3-devel-docs, gcr-devel, polkit-docs, libgweather-
     devel, harfbuzz-devel, libsecret-devel, json-glib-devel, libgdata-
     devel, p11-kit-devel, gtk-doc)

^^^ gtk-doc is explicitly exempt

[x]: %build honors applicable compiler flags or justifies otherwise.
[ ]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.


Rpmlint
-------
Checking: libu2f-server-1.0.1-1.fc21.x86_64.rpm
          u2f-server-1.0.1-1.fc21.x86_64.rpm
          libu2f-server-devel-1.0.1-1.fc21.x86_64.rpm
          libu2f-server-1.0.1-1.fc21.src.rpm
libu2f-server.x86_64: W: spelling-error Summary(en_US) Yubico -> Rubicon
libu2f-server.x86_64: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
libu2f-server-devel.x86_64: W: only-non-binary-in-usr-lib
libu2f-server.src: W: spelling-error Summary(en_US) Yubico -> Rubicon
libu2f-server.src: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
libu2f-server.src:15: W: unversioned-explicit-provides bundled(gnulib)
4 packages and 0 specfiles checked; 0 errors, 6 warnings.




Rpmlint (debuginfo)
-------------------
Checking: libu2f-server-debuginfo-1.0.1-1.fc21.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
libu2f-server-devel.x86_64: W: only-non-binary-in-usr-lib
libu2f-server.x86_64: W: spelling-error Summary(en_US) Yubico -> Rubicon
libu2f-server.x86_64: W: spelling-error %description -l en_US cryptographic -> cryptography, cryptographer, crystallographic
4 packages and 0 specfiles checked; 0 errors, 3 warnings.



Requires
--------
libu2f-server-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libu2f-server(x86-64)
    libu2f-server.so.0()(64bit)

u2f-server (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libu2f-server(x86-64)
    libu2f-server.so.0()(64bit)
    libu2f-server.so.0(U2F_SERVER_0.0.0)(64bit)
    rtld(GNU_HASH)

libu2f-server (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6()(64bit)
    libcrypto.so.10()(64bit)
    libcrypto.so.10(OPENSSL_1.0.1_EC)(64bit)
    libcrypto.so.10(libcrypto.so.10)(64bit)
    libjson-c.so.2()(64bit)
    libssl.so.10()(64bit)
    libssl.so.10(libssl.so.10)(64bit)
    rtld(GNU_HASH)



Provides
--------
libu2f-server-devel:
    libu2f-server-devel
    libu2f-server-devel(x86-64)
    pkgconfig(u2f-server)

u2f-server:
    u2f-server
    u2f-server(x86-64)

libu2f-server:
    bundled(gnulib)
    libu2f-server
    libu2f-server(x86-64)
    libu2f-server.so.0()(64bit)
    libu2f-server.so.0(U2F_SERVER_0.0.0)(64bit)



Source checksums
----------------
https://developers.yubico.com/libu2f-server/Releases/libu2f-server-1.0.1.tar.xz :
  CHECKSUM(SHA256) this package     : a618f59051209d6d70c24cf42d64c9b67bd7dd5946b6dbd2c649181d7e8f1f6e
  CHECKSUM(SHA256) upstream package : a618f59051209d6d70c24cf42d64c9b67bd7dd5946b6dbd2c649181d7e8f1f6e
https://developers.yubico.com/libu2f-server/Releases/libu2f-server-1.0.1.tar.xz.sig :
  CHECKSUM(SHA256) this package     : a7e96d5acd7c55a7fd5696562a5b893328452e52caa4a822084384a98bcb95ee
  CHECKSUM(SHA256) upstream package : a7e96d5acd7c55a7fd5696562a5b893328452e52caa4a822084384a98bcb95ee


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -rn libu2f-server-1.0.1-1.fc22.src.rpm
Buildroot used: fedora-21-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 4 Seth Jennings 2015-10-27 03:13:43 UTC
Thanks Andy!  I'll clean up those things before release.

Comment 5 Fedora Update System 2015-10-27 15:10:31 UTC
libu2f-server-1.0.1-2.fc23 has been submitted as an update to Fedora 23. https://bodhi.fedoraproject.org/updates/FEDORA-2015-dd89e579ec

Comment 6 Fedora Update System 2015-10-27 15:13:35 UTC
libu2f-server-1.0.1-2.fc22 has been submitted as an update to Fedora 22. https://bodhi.fedoraproject.org/updates/FEDORA-2015-8fa0d9928f

Comment 7 Fedora Update System 2015-10-31 15:53:07 UTC
libu2f-server-1.0.1-2.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update libu2f-server'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-dd89e579ec

Comment 8 Fedora Update System 2015-11-02 00:28:16 UTC
libu2f-server-1.0.1-2.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.
If you want to test the update, you can install it with
$ su -c 'dnf --enablerepo=updates-testing update libu2f-server'
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-8fa0d9928f

Comment 9 Upstream Release Monitoring 2015-11-12 12:38:58 UTC
jjelen's scratch build of yubico-piv-tool?#f493f908260c8e3946798b6730c4e20e37b367fa for git://pkgs.fedoraproject.org/yubico-piv-tool?#f493f908260c8e3946798b6730c4e20e37b367fa and rawhide failed http://koji.fedoraproject.org/koji/taskinfo?taskID=11804105

Comment 10 Fedora Update System 2015-11-12 23:29:24 UTC
libu2f-server-1.0.1-2.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 11 Fedora Update System 2015-11-13 01:52:55 UTC
libu2f-server-1.0.1-2.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.